#include <IE.au3>
#include <Array.au3>

Global $oIE

;_KlaueAccountDaten() :D
_PayPal_Login("PayPal_Email", "PayPal_Password")
_PayPal_TransactionHistory_Download("20.05.2016", @ScriptDir & "\Kontoauszug.txt")
_PayPal_Logout()

Func _PayPal_Login(const $S_USERNAME, const $S_PASSWORD)
	Do
		$oIE = _IECreate("https://www.paypal.com", 0, 0) ;Setz den letzten Parameter auf 1 wenn du sehen willst was passiert.
	Until IsObj($oIE)

	__IELoadWait($oIE)

	;Schon eingeloggt?
	If Not StringInStr(_IEPropertyGet($oIE, "locationurl"), "myaccount/home") Then
		_IENavigate($oIE, "https://www.paypal.com/signin")

		Sleep(250)
		__IELoadWait($oIE)

		$oEmail  = _IEGetObjById($oIE, "email")
		$oPass 	 = _IEGetObjById($oIE, "password")
		$oSubmit = _IEGetObjById($oIE, "btnLogin")

		_IEFormElementSetValue($oEmail, $S_USERNAME)
		_IEFormElementSetValue($oPass, $S_PASSWORD)
		_IEAction($oSubmit, "click")

		__IELoadWait($oIE)

		Sleep(6000) ;Bleibt noch auf der Login-Seite aber loggt ein, deshalb zur Sicherheit lieber 6sek sleepen.
		__IELoadWait($oIE)
	EndIf
EndFunc

Func _PayPal_TransactionHistory_Download($sDate, $sPath = @ScriptDir & "\Kontoauszug.txt")
	_IENavigate($oIE, "https://history.paypal.com/de/cgi-bin/webscr?cmd=_history")

	Sleep(250)
	_IELoadWait($oIE)

	$oDatum = _IEGetObjById($oIE, "from_date")
	_IEFormElementSetValue($oDatum, $sDate)

	$oSubmit = _IEGetObjById($oIE, "show")
	_IEAction($oSubmit, "click")

	__IELoadWait($oIE)

	$sSource = _IEDocReadHTML($oIE)

	$aPayments = StringRegExp($sSource, """(https:\/\/history\.paypal\.com\/de\/cgi-bin\/webscr\?cmd=%5fhistory%2ddetails&amp;info=.+?)"">Details", 3)

	FileDelete($sPath)

	If UBound($aPayments) Then
		Local $sFile = ""

		For $i = 0 To UBound($aPayments) - 1
			_IENavigate($oIE, StringReplace($aPayments[$i], "&amp;", "&"))
			__IELoadWait($oIE)

			$sSource = _IEDocReadHTML($oIE)

			$sFile &= (StringRegExp($sSource, "(Zahlungsquelle|Abbuchung)") ? "AUSGANG" : "EINGANG") & ":"

			$aDatum = StringRegExp($sSource, "<td (?:align=""right"" )?class=""label"">Datum:<\/td><td><br class=""textSpacer""><\/td>" & _
											 "<td class=""small"">(.+?)<\/td>", 3)

			If UBound($aDatum) Then
				$sDatum = StringReplace($aDatum[UBound($aDatum) - 1], "&#x2e;", ".")
				$sDatum = StringReplace($aDatum[UBound($aDatum) - 1], "&#x20;", " ")
				$sFile &= $sDatum & ":"
			Else
				$sFile &= "DATUM_AUSLESEN_FEHLER" & ":" ;Sollte eigentlich nie auftreten.
			EndIf

			$aEmail = StringRegExp($sSource, "<td class=""label"">E-Mail:<\/td><td><br class=""textspacer""><\/td>" & _
											 "<td class=""small"">(.+?)<\/td>", 3)

			If UBound($aEmail) Then
				$sEmail = StringReplace($aEmail[0], "&#x40;", "@")
				$sEmail = StringReplace($aEmail[0], "&#x2e;", ".")
				$sFile &= $sEmail & ":"
			Else
				$sFile &= "EMAIL_NICHT_VERFGBAR" & ":" ;Sollte eigentlich nie auftreten.
				;Tritt nur auf wenn es eine Transaktion mit dem Titel "verzgerte Verfgbarkeit von ..." gibt
			EndIf

			$aBetrag = StringRegExp($sSource, "<td class=""label(?: smallEmphasis)?"">(?:Gesamtbetrag|Betrag):<\/td><td><br class=""textSpacer""><\/td>" & _
											  "<td class=""small"">(.+?)</td>", 3)

			If UBound($aBetrag) Then
				$sBetrag = StringReplace($aBetrag[0], "&#x2d;", "-")
				$sBetrag = StringReplace($aBetrag[0], "&#x2c;", ",")
				$sBetrag = StringReplace($aBetrag[0], "&#x20;", " ")
				$sFile &= $sBetrag
			Else
				$sFile &= "BETRAG_AUSLESEN_FEHLER" ;Sollte eigentlich nie auftreten.
			EndIf

			$sFile &= @CRLF
		Next

		$sFile = StringTrimRight($sFile, 2) ;Letzten Zeilenumbruch lschen

		FileDelete($sPath)
		FileWrite($sPath, $sFile)
	EndIf
EndFunc

Func _PayPal_Logout()
	_IENavigate($oIE, "https://www.paypal.com/myaccount/logout")
	__IELoadWait($oIE)
	_IEQuit($oIE)
EndFunc

Func __IELoadWait($oIE)
	Sleep(300)
	_IELoadWait($oIE)
EndFunc